"HANOI" by Thomas Rau

Chapter 1 - Neue Klassen

A disc is a kind of supporter.
It is always portable.
It has a number called size.
The size is usually 0.
The description usually is "A disc. They come in different sizes, and you can only put smaller discs on top of bigger ones."

A stake is a kind of supporter.
It is never portable.
The description usually is "A long and thick bamboo stick. You can put discs on it."

Chapter 2 - Objekte in unserer Modellwelt

[ein zimmer]
The Windowless Room is a room.
The description usually is "You are in a room without doors or windows. You wonder where the light comes from."

[drei bambusstäbe, ein roter, grüner und blauer]
The red stake, the green stake and the blue stake are stakes in the Windowless Room.

[drei scheiben aufeinander auf dem roten stab]
Disc 3 is a disc on the red stake. The size is 3.
Disc 2 is a disc on Disc 3. The size is 2.
Disc 1 is a disc on Disc 2. The size is 1.

[der spieler kann nur eins auf einmal nehmen]
The carrying capacity of the player is 1.

Chapter 3 - Regeln über das Nehmen und Ablegen von Scheiben

Section 1 - Nur die oberste Scheibe

[man kann eine scheibe nur nehmen, wenn nichts auf ihr ist]
Instead of taking a disc (called target):
	if the number of things on the target is 0:
		continue the action;
	otherwise:
		say "You can only take the top disc."

Section 2 - Scheibe auf Scheibe

[man kann eine scheibe nur auf eine andere legen, wenn nichts darauf ist und wenn sie kleiner ist]
Instead of putting a disc (called the load) on a disc (called the target):
	if something is on the target:
		say "You can only put a disc on an empty disc.";
	otherwise:
		if the size of the load is greater than the size of the target:
			say "You can only put a smaller disc on a larger one.";
		otherwise:
			continue the action.

Section 3 - Scheibe auf Stab
	
[wenn man eine scheibe auf einen stab legt, wird sie darauf gelegt, wenn der stab leer ist, sonst wird versucht, auf die oberste scheibe zu legen]
Instead of putting a disc (called the load) on a stake (called the target):
	if something is on the target:
		try putting the load on the top of the target;
	otherwise:
		continue the action.
		
[eine methode, um die oberste scheibe eines stabs herauszufinden]
To decide what disc is the top of (the target - a stake):
	let x be a random disc supported by the target;
	while x supports a disc:
		now x is a random disc supported by x;
	decide on x.

Section 4 - Keine Scheibe auf den Boden bitte

[sonst wäre das ja einfach]
Instead of dropping a disc:
	say "You can only put discs on other discs or stakes."


Chapter 4 - Andere Regeln

[siegbedingung]
Every turn:
	try looking;
	If all discs are enclosed by the blue stake:
		end the game saying "Finished!"


Chapter 5 - Verzierungen

Section 1 - Begrüßung am Anfang

[text am anfang]
When play begins:
	say "You are in a strange room without doors or windows. You see three stakes in the room (upright bamboo poles): a red, a green and a blue stake. A number of smaller and smaller discs are piled on the red stake.[paragraph break]You don't know where you are and how you got here. But you know you must do one thing... and that is:[line break]Get all the discs from the red stake on the left on to the blue stake on the right.[paragraph break]But you can only put a smaller disc on top of a bigger one. And you can only take and carry one disc at time.[paragraph break](If you need help, type HELP.)"
	
Section 2 - Help

[hilfe]
Understand "HELP" as a mistake ("Try writing: 'take disc 1', and then 'put  disc 1 on disc 2' or 'put disc 1 on the green stake'.[line break]You can also write 'put disc 1 on green', which is shorter.[paragraph break]If you don't carry the disc that you want to put somewhere, you will automatically try to pick it up.").
	
Section 3 - Testen
			
[testausführung, mit "test me" aufgerufen]
Test me with "put disc 1 on blue / put disc 2 on green / put disc 1 on green / put disc 3 on blue / put disc 1 on red / put disc 2 on blue"

Chapter 6 -Rekursiver Algorithmus

[rekursive methode]
To move (i - a number) discs from (start - a stake) via ( dummy -  a stake) to (goal - a stake):
	if i is greater than 0:
		move (i minus one) discs from start via goal to dummy;
		try putting the top of start on goal;
		move (i minus one) discs from dummy via start to goal;

[wann die rekursive methode aufgerufen wird]
Instead of waiting:
	if all discs are enclosed by the red stake:
		let l be the number of discs enclosed by the red stake;
		move l discs from red stake via green stake to blue stake;
	otherwise:
		say "You can only do that from the starting position."